/**
 * The purpose of this module is to override the base webpack dev config to suit server side rendering
 *
 * Author: Pubudu Dodangoda
 */

'use strict';

const clone = require('immer').default;
const HtmlWebpackPlugin = require('html-webpack-plugin');
const InterpolateHtmlPlugin = require('react-dev-utils/InterpolateHtmlPlugin');

const baseConfig = require('./webpack.config.override')('development');

module.exports = clone(baseConfig, config => {
  config.plugins = config.plugins.filter(plugin => {
    return (
      !(plugin instanceof HtmlWebpackPlugin) &&
      !(plugin instanceof InterpolateHtmlPlugin)
    );
  });

  return config;
});
