/**
 * The purpose of this module is to override the webpack dev server config creator module to support server side rendering
 *
 * Author: Pubudu Dodangoda
 */

'use strict';

const clone = require('immer').default;
const createConfig = require('./webpackDevServer.config');
const paths = require('./paths');

module.exports = function(proxy, allowedHost) {
  const baseConfig = createConfig(proxy, allowedHost);
  return clone(baseConfig, config => {
    config.setup = function(app) {
      app.get('/', (req, res, next) => {
        global.appPromise
          .then(() => {
            const app = require(paths.nodeBuildAppJs).default;
            app.handle(req, res);
          })
          .catch(next);
      });
    };

    config.after = function(app) {
      app.use((req, res, next) => {
        global.appPromise
          .then(() => {
            const app = require(paths.nodeBuildAppJs).default;
            app.handle(req, res);
          })
          .catch(next);
      });
    };
  });
};
